//+-------------------------------------------------------------------------+
//|       2011                                              Fractals_v2.mq4 |
//| The author of idea Mercur & Grein.  Coding by Grein.                    |  
//+-------------------------------------------------------------------------+

#property indicator_chart_window
#property indicator_buffers 2
#property indicator_color1  Lime
#property indicator_color2  Red
#property indicator_width1  1
#property indicator_width2  1


extern int     Fractal_bars  = 5; //     
extern int     Gap_arrow     = 3; //    

double Fractal_H, Fractal_L;

double Fractal_High[];
double Fractal_Low[];

double Fractal_High_gap[];
double Fractal_Low_gap[];


//-------------------------------------------------------------------------------------------------------------
int init()
{
   IndicatorBuffers(4);

   SetIndexBuffer (0,Fractal_High_gap); SetIndexStyle(0,DRAW_ARROW);SetIndexArrow(0, 170); 
   SetIndexBuffer (1,Fractal_Low_gap);  SetIndexStyle(1,DRAW_ARROW);SetIndexArrow(1, 170);
   SetIndexBuffer (2,Fractal_High);
   SetIndexBuffer (3,Fractal_Low);

   IndicatorShortName("Fractal_bars = "+Fractal_bars);
   return(0);
}
//-------------------------------------------------------------------------------------------------------------
int deinit(){ return(0);}
//-------------------------------------------------------------------------------------------------------------
int start()
 {
   int  counted_bars=IndicatorCounted();
   int  i,limit;
   if (counted_bars<0) return(-1);
   if (counted_bars>0) counted_bars--;
   limit=Bars-counted_bars;

   for(i=limit;i>=0;i--)
   {
      Fractal_H = High[iHighest(NULL,0,MODE_HIGH,Fractal_bars,i)]; 
      Fractal_L = Low [iLowest (NULL,0,MODE_LOW, Fractal_bars,i)];      
      
      if (Fractal_H > Fractal_High[i+1])
       {
        Fractal_High[i]     = Fractal_H;
        Fractal_High_gap[i] = Fractal_H + Gap_arrow*Point;
       }
        else {Fractal_High_gap[i] = EMPTY_VALUE; Fractal_High[i] = Fractal_H;}
      
      
      if (Fractal_L < Fractal_Low[i+1])
       {
        Fractal_Low[i]     = Fractal_L;
        Fractal_Low_gap[i] = Fractal_L - Gap_arrow*Point;
       }
        else {Fractal_Low_gap[i] = EMPTY_VALUE; Fractal_Low[i] = Fractal_L;}

   }
   return(0);
}
//-------------------------------------------------------------------------------------------------------------

  
      